﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.SharePoint.Administration;

namespace SecurityEventManagement
{
    class SecurityEventReceiverServiceInstance : SPWindowsServiceInstance
    {
        public const string serviceInstanceName = "SecurityEventReceiverServiceInstance";

        public SecurityEventReceiverServiceInstance()
        {
        }

        public SecurityEventReceiverServiceInstance(SPWindowsService spWinService)
            : this(SPServer.Local, spWinService)
        {
        }

        public SecurityEventReceiverServiceInstance(SPServer spServer, SPWindowsService spWinService)
            : this(serviceInstanceName, spServer, spWinService)
        {
        }

        public SecurityEventReceiverServiceInstance(string siName, SPServer spServer, SPWindowsService spWinService)
            : base(siName, spServer, spWinService)
        {
        }

        public override SPActionLink ProvisionLink
        {
            get
            {
                return new SPActionLink(
                    SPActionLinkType.ObjectModel,
                    string.Empty,
                    string.Format("You have chosen to enable the services: "
                        + "{0} and {1} on server: {2}. "
                        + "Do you want to continue?",
                        SecurityEventHandlerService.ntServiceName,
                        SecurityEventReceiverService.ntServiceName,
                        this.Server.Name));
            }
        }

        public override void Provision()
        {
            base.Provision();

            SecurityEventHandlerServiceInstance EventHandlerInstance =
                this.Server.ServiceInstances.
                GetValue<SecurityEventHandlerServiceInstance>(
                SecurityEventHandlerServiceInstance.serviceInstanceName);
            if (EventHandlerInstance != null)
                EventHandlerInstance.Provision();
        }

        public override SPActionLink UnprovisionLink
        {
            get
            {
                return new SPActionLink(
                    SPActionLinkType.ObjectModel, 
                    string.Empty,
                    string.Format("You have chosen to disable the services: "
                        + "{0} and {1} on server: {2}. "
                        + "Do you want to continue?",
                        SecurityEventHandlerService.ntServiceName,
                        SecurityEventReceiverService.ntServiceName,
                        this.Server.Name));
            }
        }

        public override void Unprovision()
        {
            SecurityEventHandlerServiceInstance EventHandlerInstance =
                this.Server.ServiceInstances.
                GetValue<SecurityEventHandlerServiceInstance>(
                SecurityEventHandlerServiceInstance.serviceInstanceName);
            if (EventHandlerInstance != null)
                EventHandlerInstance.Unprovision();

            base.Unprovision();
        }
    }
}
