﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace SecurityEventHandler
{
    class XmlUpdateRequest : XmlDocument
    {
        public XmlUpdateRequest()
        {
            this.LoadXml("<UpdateRequest />");
        }

        /// <summary>
        /// Adds a new child node with the specified name and value to this object's DocumentElement.
        /// </summary>
        /// <param name="Name">The name of the node.</param>
        /// <param name="Value">The value of the node.</param>
        public XmlNode AddNode(string Name, string Value)
        {
            XmlNode node = this.CreateElement(Name);
            node.InnerText = Value;
            return this.DocumentElement.AppendChild(node);
        }

        public string OuterXmlBase64Encoded
        {
            get
            {
                UnicodeEncoding ue = new UnicodeEncoding();
                return Convert.ToBase64String(ue.GetBytes(this.OuterXml));
            }
        }
    }
}